package ch.ethz.infsec.jtestdataaccessor.nodes;

/**
 * Abstract {@link Value} class - {@link Function} and {@link SimpleValue} are
 * examples of classes implementing this class, they may be used where a value
 * is needed.
 * 
 * @author ms
 * 
 */
public abstract class Value extends Argument {

	/**
	 * Get the value of the object.
	 * 
	 * @return the value.
	 * @throws Throwable
	 *             might be thrown if the result is generated by a function
	 *             which itself has thrown an exception.
	 */
	abstract public Object getValue() throws Throwable;

}